#include-once
#include <AutoItConstants.au3>; $EXITCLOSE_...
#include <FileConstants.au3>;   $STR_NOCOUNT
#include "auerloConstants.au3"

Global       $__g_aAUERLO_LvlTxt[$AUERLO_LVL__ENUM]
			 $__g_aAUERLO_LvlTxt[$AUERLO_LVL_TRACE]     = 'trace'
			 $__g_aAUERLO_LvlTxt[$AUERLO_LVL_DEBUG]     = 'debug'
			 $__g_aAUERLO_LvlTxt[$AUERLO_LVL_INFO]      = 'info'
			 $__g_aAUERLO_LvlTxt[$AUERLO_LVL_WARNING]   = 'warning'
			 $__g_aAUERLO_LvlTxt[$AUERLO_LVL_ERROR]     = 'error'
			 $__g_aAUERLO_LvlTxt[$AUERLO_LVL_FATAL]     = 'fatal'
Global       $__g_aAUERLO_ConPfx[$AUERLO_LVL__ENUM]
			 $__g_aAUERLO_ConPfx[$AUERLO_LVL_TRACE]     = '+'
			 $__g_aAUERLO_ConPfx[$AUERLO_LVL_DEBUG]     = '+'
			 $__g_aAUERLO_ConPfx[$AUERLO_LVL_INFO]      = '>'
			 $__g_aAUERLO_ConPfx[$AUERLO_LVL_WARNING]   = '-'
			 $__g_aAUERLO_ConPfx[$AUERLO_LVL_ERROR]     = '!'
			 $__g_aAUERLO_ConPfx[$AUERLO_LVL_FATAL]     = '!'
Global       $__g_aAUERLO_AtrTxt[$AUERLO_ATR__ENUM]
			 $__g_aAUERLO_AtrTxt[$AUERLO_ATR_DATETIME]  = 'date/time'
			 $__g_aAUERLO_AtrTxt[$AUERLO_ATR_LEVEL]     = 'log level'
			 $__g_aAUERLO_AtrTxt[$AUERLO_ATR_LINE]      = '@ScriptLineNumber/$oError.scriptline'
			 $__g_aAUERLO_AtrTxt[$AUERLO_ATR_ERROR]     = '@error/@exitCode/$oError.number/_WinAPI_GetLastError()'
			 $__g_aAUERLO_AtrTxt[$AUERLO_ATR_EXTENDED]  = '@extended/@exitMethod/$oError.retcode'
			 $__g_aAUERLO_AtrTxt[$AUERLO_ATR_MESSAGE]   = 'message'
Global       $__g_aAUERLO_MtdTxt[$AUERLO_MTD__ENUM]
			 $__g_aAUERLO_MtdTxt[$EXITCLOSE_NORMAL]     = 'end of script'
			 $__g_aAUERLO_MtdTxt[$EXITCLOSE_BYEXIT]     = 'Exit keyword'
			 $__g_aAUERLO_MtdTxt[$EXITCLOSE_BYCLICK]    = 'systray click'
			 $__g_aAUERLO_MtdTxt[$EXITCLOSE_BYLOGOFF]   = 'Windows user account logout'
			 $__g_aAUERLO_MtdTxt[$EXITCLOSE_BYSHUTDOWN] = 'Windows shutdown'
Global Const $__g_aAUERLO_ExcTxt                        = StringSplit( _; As per https://www.autoitscript.com/autoit3/docs/appendix/Exitcodes.htm
															'Unable to open the script file.' & @LF & _
															'Badly formatted "Func" statement.' & @LF & _
															'Unable to parse line.' & @LF & _
															'Missing right bracket ")" in expression.' & @LF & _
															'Missing operator in expression.' & @LF & _
															'Unbalanced brackets in expression.' & @LF & _
															'Error in expression.' & @LF & _
															'Error parsing function call.' & @LF & _
															'Incorrect number of parameters in function call.' & @LF & _
															'"ReDim" used without an array variable.' & @LF & _
															'Illegal text at the end of statement (one statement per line).' & @LF & _
															'"If" statement has no matching "EndIf" statement.' & @LF & _
															'"Else" statement with no matching "If" statement.' & @LF & _
															'"EndIf" statement with no matching "If" statement.' & @LF & _
															'Too many "Else" statements for matching "If" statement.' & @LF & _
															'"While" statement has no matching "WEnd" statement.' & @LF & _
															'"WEnd" statement with no matching "While" statement.' & @LF & _
															'Variable used without being declared.' & @LF & _
															'Array variable has incorrect number of subscripts or subscript dimension range exceeded.' & @LF & _
															'Array variable subscript badly formatted.' & @LF & _
															'Subscript used with non-Array variable.' & @LF & _
															'Too many subscripts used for an array.' & @LF & _
															'Missing subscript dimensions in "Dim" statement.' & @LF & _
															'No variable given for "Dim", "Local", "Global" or "Const" statement.' & @LF & _
															'Expected a "=" operator in assignment statement.' & @LF & _
															'Invalid keyword at the start of this line.' & @LF & _
															'Array maximum size exceeded.' & @LF & _
															'"Func" statement has no matching "EndFunc".' & @LF & _
															'Duplicate function name.' & @LF & _
															'Unknown function name.' & @LF & _
															'Unknown macro.' & @LF & _
															'Unable to execute the external program.' & @LF & _
															'0x7FFFF088' & @LF & _
															'0x7FFFF089' & @LF & _
															'0x7FFFF08A' & @LF & _
															'Unknown option or bad parameter specified.' & @LF & _
															'Unable to load the internet libraries.' & @LF & _
															'0x7FFFF08D' & @LF & _
															'Unable to open file, the maximum number of open files has been exceeded.' & @LF & _
															'Invalid file handle used.' & @LF & _
															'Invalid file filter given.' & @LF & _
															'Expected a variable in user function call.' & @LF & _
															'"Do" statement has no matching "Until" statement.' & @LF & _
															'"Until" statement with no matching "Do" statement.' & @LF & _
															'"For" statement is badly formatted.' & @LF & _
															'"Next" statement with no matching "For" statement.' & @LF & _
															'"ExitLoop/ContinueLoop" statements only valid from inside a For/Do/While loop.' & @LF & _
															'"For" statement has no matching "Next" statement.' & @LF & _
															'"Case" statement with no matching "Select"or "Switch" statement.' & @LF & _
															'"EndSelect" statement with no matching "Select" statement.' & @LF & _
															'Recursion level has been exceeded - AutoIt will quit to prevent stack overflow.' & @LF & _
															'Unable to access RunAs API.' & @LF & _
															'String missing closing quote.' & @LF & _
															'0x7FFFF09D' & @LF & _
															'Badly formated variable or macro.' & @LF & _
															'This keyword cannot be used after a "Then" keyword.' & @LF & _
															'"Select" statement is missing "EndSelect" or "Case" statement.' & @LF & _
															'"If" statements must have a "Then" keyword.' & @LF & _
															'0x7FFFF0A2' & @LF & _
															'Cannot assign values to constants.' & @LF & _
															'Cannot make existing variables into constants.' & @LF & _
															'0x7FFFF0A5' & @LF & _
															'0x7FFFF0A6' & @LF & _
															'Object referenced outside a "With" statement.' & @LF & _
															'Nested "With" statements are not allowed.' & @LF & _
															'Variable must be of type "Object".' & @LF & _
															'The requested action with this object has failed.' & @LF & _
															'Variable appears more than once in function declaration.' & @LF & _
															'ReDim array can not be initialized in this manner.' & @LF & _
															'An array variable can not be used in this manner.' & @LF & _
															'Can not redeclare a constant.' & @LF & _
															'Can not redeclare a parameter inside a user function.' & @LF & _
															'Can pass constants by reference only to parameters with "Const" keyword.' & @LF & _
															'Can not initialize a variable with itself.' & @LF & _
															'Incorrect way to use this parameter.' & @LF & _
															'"EndSwitch" statement with no matching "Switch" statement.' & @LF & _
															'"Switch" statement is missing "EndSwitch" or "Case" statement.' & @LF & _
															'"ContinueCase" statement with no matching "Select"or "Switch" statement.' & @LF & _
															'Assert Failed!' & @LF & _
															'AutoIt has encountered a fatal crash as a result of:\r Unable to execute DllCall.' & @LF & _
															'Obsolete function/parameter.' & @LF & _
															'Invalid Exitcode (reserved for AutoIt internal use).', _
															@LF, _
															$STR_NOCOUNT _
														  )
